# marble machinations
(working title)

logic mostly like https://git.crispypin.cc/CrispyPin/marble

file hierarchy
```
- assets/
- storage/
  - levels/
    - 00_zeroes.json
    - 01_cat.json
    - 02_parse.json
    - 99_sandbox.json
  - solutions/
    - 00_zeroes/
      - solution_0.json
      - solution_1.json
    - factorial_194726/
      - solution_0.json
      - solution_1.json
  - blueprints
    - blueprint_0.json
  - custom_levels/
    - factorial_194726.json
```

`00_zeroes.json`
```json
{
    "id": "00_zeroes",
    "name": "Zeroes",
    "description": "learn how to output data",
    "init_board": null,
    "inputs": [],
    "outputs": [0, 0, 0, 0, 0, 0, 0, 0]
}
```
`00_zeroes/solution_0.json`
```json
{
    "level_id": "00_zeroes", //redundant, useful if sharing solution files?
    "name": "unnamed 1",
    "board": "oo\nP*\n|-"
}
```

`blueprints/blueprint_0.json`
```json
{
    "name": "fast printer",
    "board": "oo\nP*\n|-"
}
```